package server

import (
	"cfTest/cloudflareApi/loadBalancerPool"
	"context"
	"reflect"
	"testing"
)

func TestLoadBalancerPoolServer_Create(t *testing.T) {
	type fields struct {
		UnimplementedLoadBalancerPoolCloudflareServer loadBalancerPool.UnimplementedLoadBalancerPoolCloudflareServer
	}
	type args struct {
		ctx     context.Context
		request *loadBalancerPool.LoadBalancerPoolRequest
	}
	tests := []struct {
		name    string
		fields  fields
		args    args
		want    *loadBalancerPool.LoadBalancerPool
		wantErr bool
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := LoadBalancerPoolServer{
				UnimplementedLoadBalancerPoolCloudflareServer: tt.fields.UnimplementedLoadBalancerPoolCloudflareServer,
			}
			got, err := d.Create(tt.args.ctx, tt.args.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("Create() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("Create() got = %v, want %v", got, tt.want)
			}
		})
	}
}

func TestLoadBalancerPoolServer_Delete(t *testing.T) {
	type fields struct {
		UnimplementedLoadBalancerPoolCloudflareServer loadBalancerPool.UnimplementedLoadBalancerPoolCloudflareServer
	}
	type args struct {
		ctx     context.Context
		request *loadBalancerPool.IdRequest
	}
	tests := []struct {
		name    string
		fields  fields
		args    args
		want    *loadBalancerPool.Empty
		wantErr bool
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := LoadBalancerPoolServer{
				UnimplementedLoadBalancerPoolCloudflareServer: tt.fields.UnimplementedLoadBalancerPoolCloudflareServer,
			}
			got, err := d.Delete(tt.args.ctx, tt.args.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("Delete() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("Delete() got = %v, want %v", got, tt.want)
			}
		})
	}
}

func TestLoadBalancerPoolServer_List(t *testing.T) {
	type fields struct {
		UnimplementedLoadBalancerPoolCloudflareServer loadBalancerPool.UnimplementedLoadBalancerPoolCloudflareServer
	}
	type args struct {
		ctx     context.Context
		request *loadBalancerPool.ListRequest
	}
	tests := []struct {
		name    string
		fields  fields
		args    args
		want    *loadBalancerPool.LoadBalancerPoolList
		wantErr bool
	}{
		{
			name:   "1",
			fields: fields{},
			args: args{
				ctx: nil,
				request: &loadBalancerPool.ListRequest{
					ApiKey:   "2cc87f6213a4c40e5a90c8dced3c9c577eda5",
					ApiEmail: "ll@centcloud.net",
				},
			},
			want:    nil,
			wantErr: false,
		},
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := LoadBalancerPoolServer{
				UnimplementedLoadBalancerPoolCloudflareServer: tt.fields.UnimplementedLoadBalancerPoolCloudflareServer,
			}
			got, err := d.List(tt.args.ctx, tt.args.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("List() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("List() got = %v, want %v", got, tt.want)
			}
		})
	}
}

func TestLoadBalancerPoolServer_Update(t *testing.T) {
	type fields struct {
		UnimplementedLoadBalancerPoolCloudflareServer loadBalancerPool.UnimplementedLoadBalancerPoolCloudflareServer
	}
	type args struct {
		ctx     context.Context
		request *loadBalancerPool.LoadBalancerPoolRequest
	}
	tests := []struct {
		name    string
		fields  fields
		args    args
		want    *loadBalancerPool.LoadBalancerPool
		wantErr bool
	}{
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := LoadBalancerPoolServer{
				UnimplementedLoadBalancerPoolCloudflareServer: tt.fields.UnimplementedLoadBalancerPoolCloudflareServer,
			}
			got, err := d.Update(tt.args.ctx, tt.args.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("Update() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("Update() got = %v, want %v", got, tt.want)
			}
		})
	}
}

func TestLoadBalancerPoolServer_Get(t *testing.T) {
	type fields struct {
		UnimplementedLoadBalancerPoolCloudflareServer loadBalancerPool.UnimplementedLoadBalancerPoolCloudflareServer
	}
	type args struct {
		ctx     context.Context
		request *loadBalancerPool.IdRequest
	}
	tests := []struct {
		name    string
		fields  fields
		args    args
		want    *loadBalancerPool.LoadBalancerPool
		wantErr bool
	}{
		{
			name:   "1",
			fields: fields{},
			args: args{
				ctx: nil,
				request: &loadBalancerPool.IdRequest{
					ApiKey:   "2cc87f6213a4c40e5a90c8dced3c9c577eda5",
					ApiEmail: "ll@centcloud.net",
					Id:       "6c946466b3d38323661808d5655f3423",
				},
			},
			want:    nil,
			wantErr: false,
		},
		// TODO: Add test cases.
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			d := LoadBalancerPoolServer{
				UnimplementedLoadBalancerPoolCloudflareServer: tt.fields.UnimplementedLoadBalancerPoolCloudflareServer,
			}
			got, err := d.Get(tt.args.ctx, tt.args.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("Get() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if !reflect.DeepEqual(got, tt.want) {
				t.Errorf("Get() got = %v, want %v", got, tt.want)
			}
		})
	}
}
